{
   uStd, standard resources unit(something like system unit)
   Copyright (C) Dejan Boras 2011.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.

   Started on:    30.01.2011.
   Last Update:   09.02.2011.
}

{$MODE OBJFPC}{$H+}
UNIT uStd;

INTERFACE

CONST
   EmptyShortString: string[1] = '';

TYPE
   TBoolFunction = function(): boolean;

{fill a buffer quickly with zero's}
procedure Zero(var buf; size: int64);
{free a pointer, only if it is not nil}
procedure XFreeMem(var mem: pointer);

IMPLEMENTATION

procedure Zero(var buf; size: int64);
var
   left: int64;

begin
   if(size > 0) then begin
      left := size mod 4;
      if(size > 3) then
         filldword(buf, size div 4, 0);
      if(left > 0) then
         fillbyte((@buf+size-left)^, left, 0);
   end;
end;

procedure XFreeMem(var mem: pointer);
begin
   if(mem <> nil) then begin FreeMem(mem); mem := nil; end;
end;

END.
